// adventure.js
// client-side code for adventure AJAX demo

(function() {  // setup local scope

    var getRoom = function() {
	$.getJSON("/getContents", function(details) {
		var room = details.room;
	    $('#title').text(room.title);
	    $('#description').text(room.description);
	    $('.exit-door').remove();
	    $(".keys a").remove();

	    if(room.exits) {
	    	var newExitText,
		    	$newExit,
		    	$exits = $(".exit-doors");

		    room.exits.forEach(function(theExit, i) {
		    	newExitText = '<a href="#" class="exit-door room" id="' + theExit + '">' + details.exits[theExit] + '</a>';
				$newExit = $(newExitText).appendTo($exits);

				if(details.lockedExits[theExit]) {
					if(details.keys.indexOf(theExit) >= 0) {
						$newExit.addClass("unlocked");
					} else {
						$newExit.addClass("locked");
					}
				}

				$('#'+theExit).on('click', function() {
					var $this = $(this);

				    $.post("/doAction", {action: "move", room: theExit}, function(message) {
				    	if(message.match(/locked/i)) {
				    		$this.addClass("lock-warning");
				    		setTimeout(function() {
				    			$this.removeClass("lock-warning");
				    		}, 2000);
				    	} else {
				    		getRoom();
				    	}
				    });
				});
		    });
	    }

	    if(details.keyTitles) {
	    	var newKeyText,
		    	$newKey,
		    	$keys = $(".keys");

		    details.keyTitles.forEach(function(theKey, i) {
		    	newKeyText = '<a href="#" title="' + theKey + '"><span class="icon">f</span>';
		    	$newKey = $(newKeyText).appendTo($keys);
		    });
	    }
	});
    }

    $(window).load(getRoom());

})(); // finish setting up local scope (call function defined)
